SEM_POST(3)

NAME
sem_post - increment (unlock) a semaphore

LIBRARY
libc

SYNOPSIS
#include <semaphore.h>
int
sem_post(sem_t *sem);

DESCRIPTION
The sem_post() function increments (unlocks) the semaphore pointed to by sem. If there are threads blocked on the semaphore when sem_post() is called, then the highest priority thread that has been blocked the longest on the semaphore will be allowed to return from sem_wait().

The sem_post() function is signal-reentrant and may be called within signal handlers.

RETURN VALUES

ERRORS
The sem_post() function will fail if:

[EINVAL]
    The sem argument points to an invalid semaphore.

[EOVERFLOW]
    The semaphore value would exceed SEM_VALUE_MAX.

SEE ALSO
sem_getvalue(3), sem_trywait(3), sem_wait(3)

STANDARDS
The sem_post() function conforms to p1003.1-96.